#ifndef BIBLES_H
#define BIBLES_H

#define MAX_BIBLES 25
#define BIBLE_NAME_LEN 10
#define BIBLE_PATH_TCHAR			L"\\Program Files\\whbbible\\"
#define BIBLE_SEARCH_PATH_TCHAR		L"\\Program Files\\whbbible\\*"
#define BIBLE_PATH		"\\Program Files\\whbbible\\"
#define BIBLE_EXT	".TXT"
#define BOOKS_IN_BIBLE	66
#define BOOK_NAME_LEN	4


const char BIBLE_TXT[BOOKS_IN_BIBLE][BOOK_NAME_LEN] = {
		"GEN",		"EXO",		"LEV",		"NUM", 
		"DEU",		"JOS",		"JDG",		"RUT", 
		"1SA",		"2SA",		"1KI",		"2KI", 
		"1CH",		"2CH", 		"EZR",		"NEH",		
		"EST", 		"JOB",		"PSA",		"PRO",		
		"ECC", 		"SON",	 	"ISA",		"JER",		
		"LAM", 		"EZE",		"DAN", 		"HOS", 
		"JOE",		"AMO",		"OBA",		"JON", 
		"MIC",		"NAH", 		"HAB",		"ZEP", 
		"HAG",		"ZEC",		"MAL",		"MAT", 
		"MAR", 		"LUK",		"JOH",		"ACT", 
		"ROM",		"1CO",		"2CO",		"GAL", 
		"EPH",		"PHI",		"COL",		"1TH", 
		"2TH",		"1TI",		"2TI", 		"TIT", 
		"PHM",		"HEB",		"JAM",		"1PE", 
		"2PE",		"1JO", 		"2JO",		"3JO", 
		"JUD",		"REV"
};

const TCHAR SEARCH_BOOKS[5][14] = {
		L"Whole Bible",
		L"New Testament",
		L"Old Testament",
		L"Gospels",
		L"Torah"
};

const int CHAPTERS[BOOKS_IN_BIBLE] = {
		50,     40,     27,     36,     34,     24,     21,     4,
		31,     24,     22,     25,     29,     36,     10,     13,     
		10,		42,     150,    31,     12,     8,      66,     52,     
		5,		48,     12,     14,     3,      9,      1,      4,
		7,      3,      3,      3,      2,      14,     4,      28,
		16,     24,     21,     28,     16,     16,     13,     6,
		6,      4,      4,      5,      3,      6,      4,      3,
		1,      13,     5,      5,      3,      5,      1,      1,
		1,      22
};

const TCHAR BOOK_NAME[BOOKS_IN_BIBLE][17] = {
		L"Genesis",		L"Exodus",	L"Leviticus",	L"Numbers", 
		L"Deuteronomy", L"Joshua", L"Judges", L"Ruth", 
		L"1 Samuel", L"2 Samuel", L"1 Kings", L"2 Kings", 
		L"1 Chronicles", L"2 Chronicles", L"Ezra", L"Nehemiah",
		L"Esther", L"Job", L"Psalms", L"Proverbs", L"Ecclesiastes", 
		L"Songs of Solomon", L"Isaiah", L"Jeremiah", 
		L"Lamentations", L"Ezekiel", L"Daniel", L"Hosea", 
		L"Joel", L"Amos", L"Obadiah", L"Jonah", 
		L"Micah", L"Nahum", L"Habakkuk", L"Zephaniah", 
		L"Haggai", L"Zechariah", L"Malachi", L"Matthew", 
		L"Mark", L"Luke", L"John", L"Acts", 
		L"Romans", L"1 Corinthians", L"2 Corinthians", L"Galatians", 
		L"Ephesians", L"Philippians", L"Colossians", L"1 Thessalonians", 
		L"2 Thessalonians", L"1 Timothy", L"2 Timothy", L"Titus", 
		L"Philemon", L"Hebrews", L"James", L"1 Peter", 
		L"2 Peter", L"1 John", L"2 John", L"3 John", 
		L"Jude", L"Revelation"
};


const char ABBR[BOOKS_IN_BIBLE][5] = {
		"Ge ",	"Ex ",	"Lv ",	"Nm ",	"De ",	"Js ",	"Jg ",	"Ru ", 
		"1Sa ",	"2Sa ",	"1Ki ",	"2Ki ",	"1Ch ",	"2Ch ",	"Ez ",	"Ne ",	
		"Es ", 	"Jb ",	"Ps ",	"Pv ",	"Ec ",	"So ",	"Is ",	"Je ",	
		"La ", 	"Ez ",	"Da ",	"Ho ",	"Jl ",	"Am ",	"Ob ",	"Jo ", 
		"Mi ",	"Na ", 	"Ha ",	"Ze ",	"Ha ",	"Ze ",	"Ma ",	"Mt ", 
		"Mk ", 	"Lk ",	"Jn ",	"Ac ",	"Rm ",	"1Co ",	"2Co ",	"Ga ", 
		"Ep ",	"Pl ",	"Co ",	"1Th ",	"2Th ",	"1Ti ",	"2Ti ", "Tt ", 
		"Pm ",	"He ",	"Ja ",	"1Pe ",	"2Pe ",	"1Jn ",	"2Jn ",	"3Jn ", 
		"Ju ",	"Re "
};


class Bibles {
	public:
		Bibles();
		~Bibles();
		bool add(TCHAR * bible);
		int	getNum();
		TCHAR * getName(int i);
		char * getCharName(int i);

	private:
		int num;
		TCHAR *BibleNames[MAX_BIBLES];
		char *BibleCharNames[MAX_BIBLES];
		bool LoadBibles();

};



Bibles::Bibles() {
  num = 0;

  LoadBibles();
}

bool Bibles::LoadBibles() {

  WIN32_FIND_DATA FileData;   // Data structure describes the file found
  HANDLE hSearch;             // Search handle returned by FindFirstFile
//  TCHAR szMsg[100];           // String to store the error message
//  TCHAR szNewPath[MAX_PATH];  // Name and path of the file copied
//  TCHAR szDirPath[] = TEXT("\TEXTRO");

  BOOL bFinished = FALSE;


  // Start searching for .txt files in the root directory.
//  MessageBox (NULL, BIBLE_PATH_TCHAR, NULL, MB_OK );

  hSearch = FindFirstFile (BIBLE_SEARCH_PATH_TCHAR, &FileData);
  if (hSearch == INVALID_HANDLE_VALUE)
    return false;

  //MessageBox (NULL, BIBLE_SEARCH_PATH_TCHAR, NULL, MB_OK );


  // Copy each .txt file to the new directory and change it to
  // read-only, if it is not already read-only.

  while (!bFinished)
  {
    //lstrcpy (szNewPath, BIBLE_PATH_TCHAR);
//    lstrcat (szNewPath, FileData.cFileName);

	//MessageBox (NULL, FileData.cFileName, NULL, MB_OK );

	if (FileData.dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY) {
		//MessageBox (NULL, FileData.cFileName, NULL, MB_OK );
		add(FileData.cFileName);
	} 

    if (!FindNextFile (hSearch, &FileData))
    {
      bFinished = TRUE;

      if (GetLastError () != ERROR_NO_MORE_FILES)
        return false;
    }
  }

  // Close the search handle.
  FindClose (hSearch);

//  for (int j=0; j< getNum(); j++) {
//	MessageBox (NULL, getName(j), NULL, MB_OK );
//  }


  return true;
} // End of FindFileExample code


Bibles::~Bibles() {

	for (int i = 0; i < MAX_BIBLES; i++) {
		if (BibleNames[i])	delete [] BibleNames[i];
		if (BibleCharNames[i])	delete [] BibleCharNames[i];
	}

	num = 0;

}

TCHAR * Bibles::getName(int i) {
	return BibleNames[i];
}

char * Bibles::getCharName(int i) {
	return BibleCharNames[i];
}

int Bibles::getNum() {
	return num;
}



bool Bibles::add(TCHAR * bible) {
	TCHAR fullPath[MAX_PATH];
	HANDLE hSearch;
   WIN32_FIND_DATA FileData;   // Data structure describes the file found
 

	if (num >= MAX_BIBLES) //max bibles already defined
		return false;

	if (_tcslen(bible) >= BIBLE_NAME_LEN) //bible name too long
		return false;

	_tcscpy(fullPath, BIBLE_PATH_TCHAR);
	_tcscat(fullPath, bible);
	_tcscat(fullPath, L"\\GEN.TXT");
	hSearch = FindFirstFile (fullPath, &FileData);
	if (hSearch == INVALID_HANDLE_VALUE)
		return false;

	_tcscpy(fullPath, BIBLE_PATH_TCHAR);
	_tcscat(fullPath, bible);
	_tcscat(fullPath, L"\\JOH.TXT");
	hSearch = FindFirstFile (fullPath, &FileData);
	if (hSearch == INVALID_HANDLE_VALUE)
		return false;

	_tcscpy(fullPath, BIBLE_PATH_TCHAR);
	_tcscat(fullPath, bible);
	_tcscat(fullPath, L"\\HAB.TXT");
	hSearch = FindFirstFile (fullPath, &FileData);
	if (hSearch == INVALID_HANDLE_VALUE)
		return false;

	_tcscpy(fullPath, BIBLE_PATH_TCHAR);
	_tcscat(fullPath, bible);
	_tcscat(fullPath, L"\\HEB.TXT");
	hSearch = FindFirstFile (fullPath, &FileData);
	if (hSearch == INVALID_HANDLE_VALUE)
		return false;

	_tcscpy(fullPath, BIBLE_PATH_TCHAR);
	_tcscat(fullPath, bible);
	_tcscat(fullPath, L"\\REV.TXT");
	hSearch = FindFirstFile (fullPath, &FileData);
	if (hSearch == INVALID_HANDLE_VALUE)
		return false;

	BibleNames[num] = new TCHAR[BIBLE_NAME_LEN];	
	BibleCharNames[num] = new char[BIBLE_NAME_LEN];	
	_tcscpy(BibleNames[num], bible);
	WideCharToMultiByte(0, 0, bible, _tcslen(bible), BibleCharNames[num], _tcslen(bible), NULL, NULL);
	strcat(BibleCharNames[num], "\\");

	//MessageBox (NULL, BibleNames[num], NULL, MB_OK );
	num++;

	return true;


}


#endif BIBLES_H